/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c6000\d8328_62.h> */
/****************************************************************/
/****************************************************************/
/* ADS8330 driver version 2.0 for the TMS320C6x1x DSPs          */
/* Copyright  2002-2006 Texas Instruments Incorporated         */
/* All Rights Reserved                                          */
/*--------------------------------------------------------------*/
/* $Revision: 1 $                      $JustDate:  2/23/07 $    */
/* $Author: A0797073 $                                          */
/****************************************************************/
#ifndef __T8330_FN_H
#define __T8330_FN_H

#define __DCP_SP_NEW
#define __CSL_AVAILABLE
#include "tidc_api.h"

#include <csl.h>
#include <csl_mcbsp.h>
#include <csl_edma.h>

/****************************************************************/
/* STRUCTURE DEFINITION FOR CONTROL REGISTER                    */
/****************************************************************/
typedef union
{
    unsigned int value;
    struct
    {
        unsigned int reset              :1;
        unsigned int tag                :1;
        unsigned int pd_deep            :1;
        unsigned int pd_nap             :1;
        unsigned int pd_autonap         :1;
        unsigned int pin10mode          :1;
        unsigned int pin10func          :1;
        unsigned int pin10pol           :1;
        unsigned int rsv                :1;
        unsigned int convstart          :1;
        unsigned int convclk            :1;
        unsigned int chansel            :1;
        unsigned int reserved           :20;
    } control_bit;
} TADS8330CREG;

#define ADS8330_WAKEUP  (0xB0000ul)
#define ADS8330_RDCFR   (0xC0000ul)
#define ADS8330_RDDATA  (0xD0000ul)
#define ADS8330_WRCFR   (0xE0000ul)
#define ADS8330_DEFAULT (0xF0000ul)

/* Commands for dc_control()                                    */
#define ADS8330_CMD_POWERDOWN (1)
#define ADS8330_CMD_WAKEUP    (2)
/* Parameter for dc_control()                                   */
#define ADS8330_PD_DEEP (0x00040ul)
#define ADS8330_PD_NAP  (0x00080ul)
#define ADS8330_PD_AUTO (0x00100ul)


/****************************************************************/
/** \struct TADS8330
 *  Definition of the data converter object. This is the main
 *  object to work with.                                        */
/****************************************************************/
typedef struct
{
/** \var f
 *  Structure for the API function pointers.
 *  They are declared in tidc_api.h and defined in tidc_api.c.  */
/** \var *serial
 *  Pointer to serial port structure                            */
/** \var void (*fCb*) (void*)
 *  Address of callback function passed in a dc_(read|write)block.
 *  Used to signal a end of block.                              */
/** \var void (*fCb_pend*) (void*)
 *  Address of callback function passed in a dc_(read|write)block.
 *  Used to signal a end of block. Only used if the prev block is
 *  still running and the submitted must be appended            */
/** \var creg
 *  Union containing bit fields as in converter register        */
/** \var uiIntNum
 *  Used external interrupt number of DSP converters EOC signal
 *  is connected to                                             */
/** \var hTimer
 *  Handle of used timer                                        */
/** \var iTimer
 *  Number of timer as CONVST signal (if timer is used only)    */
/** \var uiTimDiv
 *  Timer divider value to generate requested frequency         */
 /** \var hEdmaRx
 *  Handle of the used DMA channel for receive pipe             */
/** \var hEdmaRx_pend
 *  Handle of parameter entry for pending block transfer (rx)   */
 /** \var hEdmaTx
 *  Handle of the used DMA channel for transmit pipe            */
/** \var hEdmaTx_pend
 *  Handle of parameter entry for pending block transfer (tx)   */
/** \var hEdma_stop
 *  Handle of the parameter entry for stopping a block transfer */
/** \var iDriverStatus
 *  Internal variable to track current status of the program.
 *  The variable can have the following value:
 *   - ADS8330_STAT_NOTINIT: resources not initialized (startup)
 *   - ADS8330_STAT_READY  : init'ed, but currently no transfer
 *   - ADS8330_STAT_RUN    : init'ed, transfer on progress
 *   - ADS8330_STAT_BUSY   : transfer on progress & pending     */
/****************************************************************/
    TTIDC3           f;             /* common functions         */
    DCP_SERIAL*      serial;        /* serial port config       */
    void(*fCb)       (void*);       /* callback function        */
    void(*fCb_pend)  (void*);       /* pending callback func    */
    TADS8330CREG     creg;          /* configuration register   */
    unsigned int     uiIntNum;      /* used external interrupt  */
    TIMER_Handle     hTimer;        /* Timer handle             */
    int              iTimer;        /* Timer, extern or auto    */
    unsigned int     uiTimDiv;      /* Timer divider value      */
    EDMA_Handle      hEdmaRx;       /* EDMA receive channel     */
    EDMA_Handle      hEdmaRx_pend;  /* EDMA pend parameter set  */
    EDMA_Handle      hEdmaTx;       /* EDMA transmit channel    */
    EDMA_Handle      hEdmaTx_pend;  /* EDMA pend parameter set  */
    EDMA_Handle      hEdma_stop;    /* EDMA stop parameter set  */
    volatile int     iDriverStatus; /* status of driver         */
} TADS8330;

/****************************************************************/
/* CONSTANTS                                                    */
/****************************************************************/
/****************************************************************/
/* define for the channel options parameter register OPT (rx)   */
/* 0100 0000 0011 0000 0000 0000 0000 0010                      */
/* |||| |||| |||| |||| |||| |||| |||| ||||                      */
/* |||| |||| |||| |||| |||| |||| |||| |||+- FS (no)             */
/* |||| |||| |||| |||| |||| |||| |||| ||+-- LINK (yes)          */
/* |||| |||| |||| |||| |||| |||| |||| |+--- PDTD (no) (C64x)    */
/* |||| |||| |||| |||| |||| |||| |||| +---- PDTS (no) (C64x)    */
/* |||| |||| |||| |||| |||| |||| |||+------ reserved            */
/* |||| |||| |||| |||| |||| |+++ +++------- ATTC (no) (C64x)    */
/* |||| |||| |||| |||| |||| +-------------- reserved            */
/* |||| |||| |||| |||| |||+---------------- ATCINT (no) (C64x)  */
/* |||| |||| |||| |||| |++----------------- TCCM (by s/w) (C64x)*/
/* |||| |||| |||| |||| +------------------- reserved            */
/* |||| |||| |||| ++++--------------------- TCC (by s/w)        */
/* |||| |||| |||+-------------------------- TCINT (yes)         */
/* |||| |||| |++--------------------------- DUM (incr)          */
/* |||| |||| +----------------------------- 2DD (no)            */
/* |||| ||++------------------------------- SUM (none)          */
/* |||| |+--------------------------------- 2DS (no)            */
/* |||+-+---------------------------------- ESIZE (32bit)       */
/* +++------------------------------------- PRI (low)           */
/****************************************************************/
#define ADS8330_EDMA_OPT_RX_VALUE (0x40300002u)


/****************************************************************/
/* define for the channel options parameter register OPT (tx)   */
/* 0010 0000 0000 0000 0000 0000 0000 0010                      */
/* |||| |||| |||| |||| |||| |||| |||| ||||                      */
/* |||| |||| |||| |||| |||| |||| |||| |||+- FS (no)             */
/* |||| |||| |||| |||| |||| |||| |||| ||+-- LINK (yes)          */
/* |||| |||| |||| |||| |||| |||| |||| |+--- PDTD (no) (C64x)    */
/* |||| |||| |||| |||| |||| |||| |||| +---- PDTS (no) (C64x)    */
/* |||| |||| |||| |||| |||| |||| |||+------ reserved            */
/* |||| |||| |||| |||| |||| |+++ +++------- ATTC (no) (C64x)    */
/* |||| |||| |||| |||| |||| +-------------- reserved            */
/* |||| |||| |||| |||| |||+---------------- ATCINT (no) (C64x)  */
/* |||| |||| |||| |||| |++----------------- TCCM (no) (C64x)    */
/* |||| |||| |||| |||| +------------------- reserved            */
/* |||| |||| |||| ++++--------------------- TCC (no)            */
/* |||| |||| |||+-------------------------- TCINT (no)          */
/* |||| |||| |++--------------------------- DUM (none)          */
/* |||| |||| +----------------------------- 2DD (no)            */
/* |||| ||++------------------------------- SUM (none)          */
/* |||| |+--------------------------------- 2DS (no)            */
/* |||+-+---------------------------------- ESIZE (32bit)       */
/* +++------------------------------------- PRI (high)          */
/****************************************************************/
#define ADS8330_EDMA_OPT_TX_VALUE (0x20000002u)

/****************************************************************/
/* define external DC object pointer(s)                         */
/****************************************************************/
extern TADS8330 Ads8330_1;
extern DCP_SERIAL serial0;


/****************************************************************/
/* function definitions                                         */
/****************************************************************/
DCPAPI TTIDCSTATUS ADS8330_configure(void *pDC);
DCPAPI TTIDCSTATUS ADS8330_control(void *pDC, int iCmd, void *pValue);
DCPAPI TTIDCSTATUS ADS8330_readsample(void *pDC, long *lData);
DCPAPI TTIDCSTATUS ADS8330_writesample(void *pDC, long lData);
DCPAPI TTIDCSTATUS ADS8330_readblock(void *pDC,
                                     void *pData,
                                     unsigned long ulCount,
                                     void (*callback) (void *));
DCPAPI TTIDCSTATUS ADS8330_writeblock(void *pDC,
                                      void *pData,
                                      unsigned long ulCount,
                                      void (*callback) (void *));
DCPAPI TTIDCSTATUS ADS8330_close(void *pDC);


#endif /*__T8328_FN_H                                           */

/****************************************************************/
/* END OF t8330_fn.h                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
